'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _validate = require('./validate');

var _validate2 = _interopRequireDefault(_validate);

var _context = require('./context');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useField = function useField(name) {
  var _React$useContext = _react2.default.useContext(_context.FormContext),
      rules = _React$useContext.rules,
      fields = _React$useContext.fields,
      setFields = _React$useContext.setFields;

  var field = fields[name];

  var handleChange = function handleChange(value, errors) {
    // if errors were already set before, lets check again
    if (field && field.errors) errors = (0, _validate2.default)(name, field.value, rules);

    setFields(function (fields) {
      return _extends({}, fields, _defineProperty({}, name, { value: value, errors: errors }));
    });
  };

  if (!field) return { handleChange: handleChange, value: '' };

  var handleBlur = function handleBlur() {
    var errors = (0, _validate2.default)(name, field.value, rules);
    handleChange(field.value, errors);
  };

  return {
    handleBlur: handleBlur,
    handleChange: handleChange,
    value: field.value,
    errors: field.errors
  };
};

exports.default = useField;